(function () {
    'use strict';

    angular
        .module('b2e')
        .directive('b2eDialog', b2eDialog);

    b2eDialog.$inject = ['$route'];
    function b2eDialog($route) {
        return {
            replace: true,
            restrict: 'E',
            controller: function($scope){
                $scope.refresh = function(dialog, templateUrl){
                    dialog.refresh({ url : templateUrl});
                };
                $scope.reload = function(doReload){
                    if(doReload) $route.reload();
                }
            },
            template: function(element, attrs){
                // title, template-url, dialog-name, is-visible, is-modal, height, width
                var height = attrs.height ? 'k-height="' +  attrs.height + '"'  : '';
                var width = attrs.width ? 'k-width="' +  attrs.width + '"'  : 'k-width="800"';
                var isModal = attrs.isModal ? attrs.isModal : true;
                var isVisible = attrs.isVisible ? attrs.isVisible : false;
                var doReload =  attrs.doReload ? attrs.doReload : true;

                return '<div kendo-window="' + attrs.dialogName + '"' +
                                            'class="bootstrapKendoFix b2e_dialog_window"' +
                                            'k-title="\'' + attrs.title + '\'"' +
                                             width +
                                             height +
                                            'k-on-open="refresh('+ attrs.dialogName + ',\'' + attrs.templateUrl + '\')"'+
                                            'k-on-close="reload(' +  doReload + ')"'+
                                            'k-visible="'+ isVisible + '"' +
                                            'k-pinned="false"' +
                                            'k-resizable="true"' +
                                            'k-animation="false"' +
                                            'k-position="{ top: 100}"' +
                                            'k-actions=\'["Maximize","Minimize","Pin","Close"]\'' +
                                            'k-modal="' + isModal + '">' +
                                            '</div>'
            }
        };
    }
})();