(function () {
    'use strict';

    angular
        .module('b2e')
        .directive('b2eKendoGrid', b2eKendoGrid);

    b2eKendoGrid.$inject = ['$timeout'];
    function b2eKendoGrid($timeout) {
        return {
            restrict: "A",
            link: function ($scope, $element, $attrs) {
                console.log("I am a kendo grid!");

                var options = $scope.$eval($attrs.kOptions) || {};

                var resizable = $attrs.b2eResizable || false;

                options.sortable = options.sortable || true;
                options.filterable = options.filterable || true;
                options.navigatable =  options.navigatable || true;
                options.selectable = options.selectable || 'row';
                options.scrollable = options.scrollable || {'virtual':'true'};

                options.dataBound = function (e) {
                    console.log("Databound triggered in directive!");
                    var grid = e.sender;
                    var firstRow = grid.tbody.find("tr.k-master-row:first");
                    if(resizable) resizeGrid();
                    grid.current(firstRow);
                    grid.select(firstRow);
                    $timeout(function () {
                        grid.table.focus();
                    }, 400)
                };

                function resizeGrid() {
                    resizeWrapper();

                    var gridElement = $("#grid"),
                        dataArea = gridElement.find(".k-grid-content"),
                        gridHeight = gridElement.innerHeight(),
                        otherElements = gridElement.children().not(".k-grid-content"),
                        otherElementsHeight = 0;
                    otherElements.each(function(){
                        otherElementsHeight += $(this).outerHeight();
                    });
                    dataArea.height(gridHeight - otherElementsHeight);
                }

                function resizeWrapper() {
                    $("#outerWrapper").height($(window).innerHeight()-$('menu').innerHeight()-$('#footer').innerHeight()
                        -$('#collapseTop').innerHeight()-$('#toolbar').innerHeight()-72);
                }

                $(window).resize(function(){
                    if(resizable)resizeGrid();
                });
            }
        };
    }
})();